/*
 * Copyright 2010 JBoss, a divison Red Hat, Inc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.jboss.errai.bus.server.io;

import java.lang.reflect.Field;
import java.util.LinkedList;

/**
 * User: christopherbrock
 * Date: 11-Aug-2010
 * Time: 10:45:40 AM
 */
public class EncodingUtil {
    private static Field[] __getAllEncodingFields(Class cls) {
        LinkedList<Field[]> heirarchy = new LinkedList<Field[]>();
        int size = 0;

        do {
            Field[] f = cls.getDeclaredFields();
            size += f.length;
            heirarchy.add(f);

        } while ((cls = cls.getSuperclass()) != Object.class);


        Field[] fields = new Field[size];
        int i = 0;
        for (Field[] fls : heirarchy) {
            for (Field f : fls) {
                fields[i++] = f;
            }
        }

        return fields;
    }

    public static Field[] getAllEncodingFields(final Class cls) {
          return EncodingCache.get(cls, new EncodingCache.ValueProvider<Field[]>() {
              public Field[] get() {
                  return __getAllEncodingFields(cls);
              }
          });
    }
}
